<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>Network</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/black.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>
		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>

		<div class="reveal">
			<div class="slides">
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h1>Introduction to Network programming</h1>
					</section>
					<section>
					    <h2>Objectives</h2>
					    <a href="https://39iosdev.gitlab.io/ccd-iqt/idf/network-programming/introduction/introduction.html" target="_blank">Introduction to Network Programming Objectives</a>
					</section>

					<section>
						<h2>Overview</h2>
						<ul>
							<li><b>Perform socket programming for TCP and UDP in Python without supervision.</b></li>
							<li><b>Understand and explain fundamental concepts of networking, at both a high level and byte level.</b></li>
							<li><b>View network traffic and explain what is occurring at a high level and at a byte level. </b></li>
							<li><b>Be able to independently gather missing information from proper sources to solve a (socket programming) problem.</b></li>
							
							
						</ul>
					</section>
					<section>
					    <h2>Network Programming Overview Cont.</h2>
					    <ul>
					        <li><b>Be able to analyze and/or debug networking issues with Wireshark, Netcat, and Python in the absence of information.</b></li>
					
					    </ul>
					</section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Environment</h2>
						<ul>
						<li>majority of the labs will use IPv4 using Python Sockets</li>
						<li>socket module programming</li>
						<li>multiple Linux Virtual Machines to simulate a network environment</li>
						
						</ul>
					</section>		
				</section>
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
					<h3>What is Networking</h3>
					<ul>
					<li>Understanding networking concepts</li>
					<li>Modeling network communication</li>
					</ul>
				</section>
				<section>
					<h3>What is "Data" Networking</h3>
					<img src="../../assets/linksys.png" alt="linksys">
					<img src="../../assets/netgear.png" alt="netgear">
				</section>
				<section>
					<img src="../../assets/serverroom.png" alt="serverroom">
				</section>
				<section>
					<h3>What is "Data" Networking?</h3>
					<img src="../../assets/DataNetworking1.png" alt="DataNetworking">
				</section>
				
				<section>
					<h3>What is "Data" networking</h3>
					<li>moving informaiton form one device to another device.</li>
				</section>
				<section>
					<h3>Understanding Data Networking</h3>
					<img src="../../assets/Data1.png" alt="Data1">
				</section>
				<section>
					<h3>Understanding Data Networking</h3>
					<img src="../../assets/Data2.png" alt="Data2">
				</section>
				<section>
					<h3>Understanding Data Networking</h3>
					<img src="../../assets/Data3.png" alt="Data3">
				</section>
				<section>
					<h3>Understanding Data Networking</h3>
					<img src="../../assets/Data4.png" alt="Data4">
				</section>
				</section>
				<section>
				<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h2>Example: Using a Telephone</h2>
						<img src="../../assets/telephone1.png" alt="tel1">

				</section>
				<section>
					<h3>Modeling Systems</h3>
					<img src="../../assets/model1.png" alt="model1">
				</section>
				</section>
				<section>
				<section>
					<h2>The OSI MODEL</h2>
						<ul>
							<li>Introduction to OSI model</li>
							<li>Modeling Telephone Call</li>
							<li>Modeling Networking with OSI</li>
						</ul>
				</section>
				<section>
					<h2>Moving information: Dissecting Communication</h2>
					<li>Local Addressing</li>
					<img src="../../assets/local1.png" alt="local1">

				</section>
				<section>
					<h3>Categorizing Data Transmissions</h3>
					<img src="../../assets/local2.png" alt="local2">
				</section>
				<section>
					<h3>Local addressing</h3>
					<img src="../../assets/local3.png" alt="local3">
				</section>
				<section>
					<h3>global addressing</h3>
					<img src="../../assets/global1.png" alt="global1">
				</section>
				<section>
					<h3>global addressing</h3>
					<img src="../../assets/global2.png" alt="global2">
				</section>
				<section>
					<h3>Establishing Communication</h3>
					<img src="../../assets/local4.png" alt="local4">
	
				</section>
				<section>
					<h3>Establishing communication</h3>
					<ul>
						<li>Pick up the phone</li>
						<li>Dial tone</li>
						<li>Dial the number</li>
						<li>Phone rings</li>
						<li>Someone picks up the phone</li>
					</ul>
				</section>
				<section>
					<h3>Conversation Protocol</h3>
					<img src="../../assets/local5.png" alt="local5">
				</section>
				<section>
					<h3>Conversation Protocol</h3>
					<img src="../../assets/local6.png" alt="local6">
				</section>
				<section>
					<h3>Conversation Protocol</h3>
					<img src="../../assets/local7.png" alt="local7">
				</section>
				<section>
					<h3>Categorizing Data Transmissions</h3>
					<img src="../../assets/local8.png" alt="local8">
				</section>
				<section>
					<h3>Conversation</h3>
					<ul>
						<li>"How is your day?"</li>
						<li>"I liked talking to you at the party."</li>
						<li>"What is the weather like by you?"</li>
					</ul>
				</section>
				<section>
					<h3>Categorizing Data Transmissions</h3>
					<img src="../../assets/local9.png" alt="local9">
			
				</section>
				</section>
				<section>
				<section>
					<h2>Protocol</h2>
					<ul>A set of rules used to move information between 2 people or devices</ul>
				</section>
				<section>
					<h2>Network Protocols</h2>
					<img src="../../assets/proto1.png" alt="proto1">
				</section>
				<section>
					<h2>Communication Model</h2>
					<li>Method of organizing information transfer to components</li>
				</section>
				<section>
					<h3>Communiation Model</h3>
					<li>The OSI model</li>
					<li>The TCP/IP model</li>
				</section>
				<section>
					<h2>Categorizing Data Transmissions</h2>
					<img src="../../assets/proto2.png" alt="proto2">
				</section>
				<section>
					<h3>Data - Website</h3>
					<img src="../../assets/proto3.png" alt="proto3">
				</section>
				<section>
					<h3>Categorizing Data Transmissions</h3>
					<img src="../../assets/proto4.png" alt="proto4">

				</section>
				<section>
					<h3>Cues- Transmission Control Protocol (TCP)</h3>
					<img src="../../assets/proto6.png" alt="proto6">
					<li>I want to make a connection to transfer data</li>
				</section>
				<section> 
				<h3>Cues- Transmission Control Protocol (TCP)</h3>
					<img src="../../assets/proto7.png" alt="proto7">
					<li>I am available for transfer data</li>
				</section>
				<section>
					<h3>Cues- Transmission Control Protocol (TCP)</h3>
					<img src="../../assets/proto8.png" alt="proto8">
					<li>okay, i'm about to send data</li>
				</section>
			</section>
			<section>
				<section>
					<h3>Categorizing Data Transmissions</h3>
					<img src="../../assets/proto9.png" alt="proto9">
				</section>
				<section>
					<h3>Global- Internet Protocol (IP)</h3>
					<img src="../../assets/proto10.png" alt="proto10">
					<li>I want to make a connection to transfer data</li>

				</section>
				<section>
					<h3>Global- Internet Protocol (IP)</h3>
					<img src="../../assets/proto11.png" alt="proto11">
					<li>I am available for transfering data</li>

				</section>
				<section>
					<h3>Global- Internet Protocol (IP)</h3>
					<img src="../../assets/proto12.png" alt="proto12">
					<li>Okay I am about to send data.</li>

				</section>
				<section>
					<h3>Global- Internet Protocol (IP)</h3>
					<img src="../../assets/proto13.png" alt="proto13">
					<li>may I get the webpage.</li>

				</section>
				<section>
					<h3>Categorizing Data Transmissions</h3>
					<img src="../../assets/proto14.png" alt="proto14">
				</section>
			</section>
			<section>
				<section>
					<h3>Local Ethernet</h3>
					<img src="../../assets/proto15.png" alt="proto15">
				</section>
				<section>
				<h3>Local Ethernet</h3>
				<img src="../../assets/proto16.png" alt="proto16">
				</section>
				<section>
					<ul>
					<h3>Continual process</h3>
					<li>Syn</li>
					<li>Syn/Ack</li>
					<li>Ack</li>
					<li>Fetch Website</li>
					</ul>
				</section>
				<section>
					<h3>Categorizing Data Transmissions</h3>
					<img src="../../assets/proto17.png" alt="proto17">
				</section>
				<section>
					<h3>media</h3>
					<img src="../../assets/proto18.png" alt="proto18">
				</section>
				<section>
					<h3>media</h3>
					<img src="../../assets/proto19.png" alt="proto19">
				</section>
			</section>
			<section>
				<section>
					<h3>OSI model</h3>
					<img src="../../assets/OSI1.png" alt="OSI1">
				</section>
				<section>
					<h3>OSI model</h3>
					<img src="../../assets/OSI2.png" alt="OSI2">
				</section>
				<section>
					<h3>OSI vs TCP/IP model</h3>
					<img src="../../assets/OSI3.png" alt="OSI3">
				</section>
				<section>
					<h3>OSI vs TCP/IP model</h3>
					<img src="../../assets/OSI4.png" alt="OSI4">
				</section>
			</section>
			<section>
				<section>
					<h3>Network programming</h3>
					<ul> network programming simply involves selecting and using a library that already supports the network operations that you need to perform</ul>
				
				</section>
				<section>
					<h3>Building Blocks</h3>
					<ul>The major purpose of this module is to introduce you to several key networking features and libraries available for Python while also teaching you about the lower-level network services on which those libraries are built.</ul>
				</section>
			
				<section>
					<section data-background-image="images/org_symbol.png" data-background-size="8%" data-background-position="top 5% left 1%">
						<h3>Python Geolocation Demo Introduction</h3>
						<ul>
							<li>Find Coordinates with python libraries</li>
						</ul>
				</section>
				</section>
			</div>
		</div>
		<footer style="background:green; left:0; right:0; bottom: 0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</footer>	
			
			
		<script src="js/reveal.js"></script>

		<script>
			// More info about config & dependencies:
			// - https://github.com/hakimel/reveal.js#configuration
			// - https://github.com/hakimel/reveal.js#dependencies
			Reveal.initialize({
				hash: true,
				menu: {
					// Specifies which side of the presentation the menu will 
					// be shown. Use 'left' or 'right'.
					side: 'left',

					// Specifies the width of the menu.
					// Can be one of the following:
					// 'normal', 'wide', 'third', 'half', 'full', or
					// any valid css length value
					width: 'normal',

					// Add slide numbers to the titles in the slide list.
					// Use 'true' or format string (same as reveal.js slide numbers)
					numbers: true,

					// Specifies which slide elements will be used for generating
					// the slide titles in the menu. The default selects the first
					// heading element found in the slide, but you can specify any
					// valid css selector and the text from the first matching
					// element will be used.
					// Note: that a section data-menu-title attribute or an element
					// with a menu-title class will take precedence over this option
					titleSelector: 'h1, h2, h3, h4, h5, h6',

					// If slides do not have a matching title, attempt to use the
					// start of the text content as the title instead
					useTextContentForMissingTitles: false,

					// Hide slides from the menu that do not have a title.
					// Set to 'true' to only list slides with titles.
					hideMissingTitles: false,

					// Adds markers to the slide titles to indicate the 
					// progress through the presentation. Set to 'false'
					// to hide the markers.
					markers: true,

					// Specify custom panels to be included in the menu, by
					// providing an array of objects with 'title', 'icon'
					// properties, and either a 'src' or 'content' property.
					custom: false,

					// Specifies the themes that will be available in the themes
					// menu panel. Set to 'true' to show the themes menu panel
					// with the default themes list. Alternatively, provide an
					// array to specify the themes to make available in the
					// themes menu panel, for example...
					// [
					//     { name: 'Black', theme: 'css/theme/black.css' },
					//     { name: 'White', theme: 'css/theme/white.css' },
					//     { name: 'League', theme: 'css/theme/league.css' }
					// ]
					themes: true,

					// Specifies the path to the default theme files. If your
					// presentation uses a different path to the standard reveal
					// layout then you need to provide this option, but only
					// when 'themes' is set to 'true'. If you provide your own 
					// list of themes or 'themes' is set to 'false' the 
					// 'themesPath' option is ignored.
					themesPath: 'css/theme/',

					// Specifies if the transitions menu panel will be shown.
					// Set to 'true' to show the transitions menu panel with
					// the default transitions list. Alternatively, provide an
					// array to specify the transitions to make available in
					// the transitions panel, for example...
					// ['None', 'Fade', 'Slide']
					transitions: true,

					// Adds a menu button to the slides to open the menu panel.
					// Set to 'false' to hide the button.
					openButton: true,

					// If 'true' allows the slide number in the presentation to
					// open the menu panel. The reveal.js slideNumber option must 
					// be displayed for this to take effect
					openSlideNumber: true,

					// If true allows the user to open and navigate the menu using
					// the keyboard. Standard keyboard interaction with reveal
					// will be disabled while the menu is open.
					keyboard: true,

					// Normally the menu will close on user actions such as
					// selecting a menu item, or clicking the presentation area.
					// If 'true', the sticky option will leave the menu open
					// until it is explicitly closed, that is, using the close
					// button or pressing the ESC or m key (when the keyboard 
					// interaction option is enabled).
					sticky: true,

					// If 'true' standard menu items will be automatically opened
					// when navigating using the keyboard. Note: this only takes 
					// effect when both the 'keyboard' and 'sticky' options are enabled.
					autoOpen: true,

					// If 'true' the menu will not be created until it is explicitly
					// requested by calling RevealMenu.init(). Note this will delay
					// the creation of all menu panels, including custom panels, and
					// the menu button.
					delayInit: false,

					// If 'true' the menu will be shown when the menu is initialised.
					openOnInit: false,

					// By default the menu will load it's own font-awesome library
					// icons. If your presentation needs to load a different
					// font-awesome library the 'loadIcons' option can be set to false
					// and the menu will not attempt to load the font-awesome library.
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
		</script>
	</body>
</html>

